#include "TrackWatcher.h"
#include "Messages.h"
#include <support/String.h>

//system headers
#include <Application.h>
#include <Message.h>
#include <Messenger.h>
#include <Roster.h>
#include <stdio.h>
#include <string.h>
#include <View.h>
#include <Font.h>
#include <Path.h>
#include <File.h>
#include <Rect.h>
#include <FindDirectory.h>
#include <unistd.h>

BString gExe;
BMessenger *bgsender;

Tasker::Tasker(LoggerWindow *winptr,const char *name, int32 priority, int32 portCapacity) : BLooper(name, priority, portCapacity),gWinPtr(winptr)
{
	Run();
}

void Tasker::MessageReceived(BMessage *mes)
{
	switch(mes->what)
	{
		case T_EXECUTE_LINE:
			{
				mes->FindString("execute",&command);
				BString exe(command);
				gExe = exe;
			}
		break;
		
		case T_RUN_COMMAND:
			{
//fread (pointer to buffer, item size, numbr of items, pointer to stream)
				FILE* runret;
				char outputa[4096];
				char runit[1024];
				strcpy(runit,gExe.String());
				strcat(runit," 2>&1");
				runret = popen(runit,"r");
				size_t nRead = fread(&outputa,1,sizeof(outputa),runret);
				outputa[nRead] = 0;
				bgsender = new BMessenger(gWinPtr,NULL,NULL);
				BMessage msg(T_RUN_RESPONSE);
				msg.AddString("response",outputa);
				bgsender->SendMessage(&msg);
			}
		break;
	}

}

Tasker::~Tasker()
{

}